<template>
  <div class="app-container">
    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.barid" filterable placeholder="栏舍名称" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="item in houseNameList" :key="item.id" :label="item.bname" :value="item.id" />
      </el-select>
      <el-select v-model="table.getdataListParm.parammaps.cowclass" filterable placeholder="牲畜类别" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="item in livestockList" :key="item.id" :label="item.mixname" :value="item.classname" />
      </el-select>
      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="handleRefresh">重置</el-button>
    </div>
    <div class="operation">
      <el-button v-if="isRoleEdit" icon="el-icon-plus" class="success" @click="handleCreate">新增</el-button>
      <el-button v-if="isRoleEdit" icon="el-icon-delete" class="danger" @click="form_delete">删除</el-button>
      <el-button v-if="isRoleEdit" icon="el-icon-copy-document" class="copy" @click="handleCopy">复制</el-button>
      <el-upload v-if="isRoleEdit" style="float: right;" :headers="headers" :data="uploadData" :action="uploadExcelUrl" :show-file-list="false" :before-upload="beforeImport" :on-success="handleImportSuccess">
        <el-button class="import" icon="el-icon-download" style="float: right;">导入</el-button>
      </el-upload>
      <el-dropdown style="float: right;margin-right: 10px;">
        <el-button class="export" icon="el-icon-upload2">导出</el-button>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item @click.native="handleExport(1)">导出模板</el-dropdown-item>
          <el-dropdown-item @click.native="handleExport(2)">导出数据</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>
    <div class="table">
      <el-table
        :key="table.tableKey"
        v-loading="table.listLoading"
        element-loading-text="给我一点时间"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%;"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        @selection-change="handleSelectionChange"
        :max-height="myHeight"
      >
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="栏舍名称" min-width="95px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.barname }}</span>
          </template>
        </el-table-column>
        <el-table-column label="牲畜类别" min-width="80px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.cowclass }}</span>
          </template>
        </el-table-column>
        <el-table-column label="牛头数" min-width="58px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.cowsum }}</span>
          </template>
        </el-table-column>
        <el-table-column label="月龄" min-width="50px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.avgmonthage }}</span>
          </template>
        </el-table-column>
        <el-table-column label="体重(kg)" min-width="50px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.bw }}</span>
          </template>
        </el-table-column>
        <el-table-column label="日增重(kg)" min-width="58px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.dayw }}</span>
          </template>
        </el-table-column>
        <el-table-column label="胎次" min-width="50px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.fetal }}</span>
          </template>
        </el-table-column>
        <el-table-column label="平均泌乳天数" min-width="80px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.avgdim }}</span>
          </template>
        </el-table-column>
        <el-table-column label="怀孕天数" min-width="50px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.dayspre }}</span>
          </template>
        </el-table-column>
        <el-table-column label="产奶量(kg/头)" min-width="60px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.product }}</span>
          </template>
        </el-table-column>
        <el-table-column label="乳脂率(%)" min-width="58px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.fat }}</span>
          </template>
        </el-table-column>
        <el-table-column label="乳蛋白率(%)" min-width="70px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.pro }}</span>
          </template>
        </el-table-column>
        <el-table-column label="乳糖率(%)" min-width="58px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.lactose }}</span>
          </template>
        </el-table-column>
        <el-table-column label="温度(℃)" min-width="50px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.tem }}</span>
          </template>
        </el-table-column>
        <el-table-column label="记录人" min-width="58px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.emp }}</span>
          </template>
        </el-table-column>
        <el-table-column label="生效时间" min-width="83px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.productdate }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="80" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button v-if="isRoleEdit" class="miniSuccess" icon="el-icon-edit-outline" @click="handleUpdate(row)" />
            <span v-if="isRoleEdit" class="centerSpan">|</span>
            <el-button v-if="isRoleEdit" class="miniDanger" icon="el-icon-delete" @click="handleRowDelete(row)" />
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="getList" />
    </div>

    <el-dialog :fullscreen="dialogFull" :visible.sync="create.dialogFormVisible" :close-on-click-modal="false"  v-if='create.dialogFormVisible' width="90%">
      <template slot="title">
        <div class="avue-crud__dialog__header">
          <span class="el-dialog__title">
            <span style="display:inline-block;width:3px;height:20px;margin-right:5px; float: left;margin-top:2px" />
            {{ textMap[create.dialogStatus] }}
          </span>
          <div class="avue-crud__dialog__menu" @click="dialogFull? dialogFull=false: dialogFull=true">
            <svg-icon v-if="dialogFull" icon-class="exit-fullscreen" />
            <svg-icon v-else icon-class="fullscreen" />
          </div>
        </div>
      </template>
      <div class="app-add">
        <el-form ref="temp" :rules="create.rules" :model="create.temp" label-position="right" label-width="135px" style="width: 100%;margin:0 auto 50px">
          <el-row>
            <el-col :span="6">
              <el-form-item label="生效日期：" prop="productdate">
                <el-date-picker v-model="create.temp.productdate" type="date" placeholder="选择日期" format="yyyy-MM-dd" value-format="yyyy-MM-dd" style="width: 100%;" :clearable="false" :disabled="create.dialogStatus=='update'" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="记录人：" prop="emp">
                <el-select ref="emp" v-model="create.temp.emp" :disabled="create.dialogStatus=='update'" filterable placeholder="记录人" class="filter-item" style="width: 100%;" @blur="blurEmp">
                  <el-option v-for="item in create.noteTakerList" :key="item.myId" :label="item.emp" :value="item.emp" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="24">
              <h3 style="width: 160px;text-align: right;">栏舍信息</h3>
            </el-col>
          </el-row>
          <el-row>
            <el-col v-if="create.dialogStatus=='create'" :span="6">
              <el-form-item label="栏舍名称：" prop="barid">
                <el-select v-model="create.temp.barid" filterable placeholder="栏舍名称" class="filter-item" style="width: 100%;" @change="changeBar">
                  <el-option v-for="item in houseNameList" :key="item.id" :label="item.bname" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col v-else :span="6">
              <el-form-item label="栏舍名称：" prop="barname">
                <el-input ref="barname" v-model="create.temp.barname" disabled class="filter-item" placeholder="barname" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="牲畜类别：" prop="cowclassid">
                <!-- <el-select v-if="create.dialogStatus=='create'" v-model="create.temp.cowclassid" filterable placeholder="牲畜类别" class="filter-item" style="width: 100%;" @change="changeCowclass">
                  <el-option v-for="item in livestockList" :key="item.id" :label="item.mixname" :value="item.id" />
                </el-select> -->
              <el-select v-if="create.dialogStatus=='create'"  v-model="create.temp.cowclassid" filterable placeholder="牲畜类别" class="filter-item" style="width:95%;padding:10px 0;" @change="changeParent">
                <el-option v-for="item in parentList" :key="item.value" :label="item.label" :value="item.value" />
              </el-select>
                <!-- <el-input v-else ref="cowclass" v-model="create.temp.cowclass" disabled class="filter-item" placeholder="牲畜类别" /> -->
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="牛头数：" prop="cowsum">
                <el-input ref="cowsum" v-model="create.temp.cowsum" class="filter-item" placeholder="正整数" type="number" step="0.01" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="环境温度（℃）：" prop="tem">
                <el-input v-model="create.temp.tem" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="24">
              <h3 style="width: 160px;text-align: right;">牛只基础信息</h3>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item label="平均月龄：" prop="avgmonthage">
                <el-input ref="avgmonthage" v-model="create.temp.avgmonthage" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="体重（kg）:" prop="bw">
                <el-input ref="bw" v-model="create.temp.bw" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="日增重（kg）:" prop="dayw">
                <el-input ref="dayw" v-model="create.temp.dayw" class="filter-item" placeholder="最多两位小数" type="number" step="0.01" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="怀孕天数：" prop="dayspre">
                <el-input ref="dayspre" v-model="create.temp.dayspre" class="filter-item" placeholder="0-280整数" type="number" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item label="胎次：" prop="fetal">
                <el-input ref="fetal" v-model="create.temp.fetal" :disabled="create.temp.bigcowclass=='后备牛' " class="filter-item" placeholder="0-20整数" type="number" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="平均泌乳天数：" prop="avgdim">
                <el-input ref="avgdim" v-model="create.temp.avgdim" :disabled="create.temp.bigcowclass=='后备牛' || create.temp.bigcowclass=='干奶牛'" class="filter-item" placeholder="正整数" type="number" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="产奶量（kg/头）：" prop="product">
                <el-input ref="product" v-model="create.temp.product" :disabled="create.temp.bigcowclass=='后备牛' || create.temp.bigcowclass=='干奶牛'" class="filter-item" placeholder="最多两位小数" type="number" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="乳脂率（%）" prop="fat">
                <el-input ref="fat" v-model="create.temp.fat" :disabled="create.temp.bigcowclass=='后备牛' || create.temp.bigcowclass=='干奶牛'" class="filter-item" placeholder="最多两位小数" type="number" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="6">
              <el-form-item label="乳蛋白率（%）：" prop="pro">
                <el-input ref="pro" v-model="create.temp.pro" :disabled="create.temp.bigcowclass=='后备牛' || create.temp.bigcowclass=='干奶牛'" class="filter-item" placeholder="最多两位小数" type="number" />
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label="乳糖率（%）：" prop="lactose">
                <el-input ref="lactose" v-model="create.temp.lactose" :disabled="create.temp.bigcowclass=='后备牛' || create.temp.bigcowclass=='干奶牛'" class="filter-item" placeholder="最多两位小数" type="number" />
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button class="cancelClose" @click="create.dialogFormVisible = false;getList()">关闭</el-button>
          <el-button v-if="create.dialogStatus==='create'" class="save" :disabled="isokDisable" @click="createDataAgain()">确认新增</el-button>
          <el-button v-if="create.dialogStatus==='create' || create.dialogStatus==='update'" class="save" :disabled="isokDisable" @click="create.dialogStatus==='create'?createData():updateData()">确认</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { GetDataByName, PostDataByName, failproccess, ExecDataByConfig, GetDataByNames, checkButtons } from '@/api/common'
import Cookies from 'js-cookie'
import { parseTime, json2excel } from '@/utils/index.js'
import Pagination from '@/components/Pagination'
import { MessageBox } from 'element-ui'
import axios from 'axios'
import { getToken } from '@/utils/auth'
export default {
  name: 'Performance',
  components: { Pagination },
  data() {
    return {
      dialogFull: false,
      isRoleEdit: [],
      requestParams: [
        { name: 'getBarListEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid') }},
        { name: 'getCowclassListEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid') }}
      ],
      houseNameList: [], // 栏舍名称
      livestockList: [], // 牲畜类别

    parentList: [], // 牲畜父类



      livestockList: [], // 牲畜类别

      table: {
        getdataListParm: {
          name: 'getBarmilkList',
          page: 1,
          offset: 1,
          pagecount: 50,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            cowclass: '',
            startTime: '',
            stopTime: '',
            inputDatetime: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        temp: {}
      },

      // 新增/编辑
      create: {
        dialogFormVisible: false,
        dialogStatus: '',
        temp: { pastureid: Cookies.get('pastureid'), productdate: parseTime(new Date(), '{y}-{m}-{d}'), emp: Cookies.get('employename'), barid: '', barname: '', cowclassid: '', cowclass: '', bigcowclass: '', cowsum: '', tem: '', avgmonthage: '', bw: '', dayw: '', dayspre: '', fetal: '', avgdim: '', product: '', fat: '', pro: '', lactose: '' },
        rules: {
          barid: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          cowclassid: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }]
        },
        getdataListParm: {
          name: 'getBarmilkEmpHis',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        noteTakerList: [] // 记录人
      },
      textMap: {
        create: '新增',
        update: '编辑'
      },

      requestParam: {},
      download: {
        getdataListParm: {
          name: 'getBarmilkList',
          page: 1,
          offset: 1,
          pagecount: 0,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            cowclass: '',
            startTime: '',
            stopTime: '',
            inputDatetime: ''
          }
        },
        list: []
      },
      isokDisable: false,
      selectList: [],
      rowStyle: { maxHeight: 30 + 'px', height: 30 + 'px' },
      cellStyle: { padding: 0 + 'px' },
      myHeight:document.documentElement.clientHeight - 85- 150 - 45
    }
  },
  computed: {
    // 设置请求头
    headers() {
      return {
        token: getToken()
      }
    },
    uploadData() {
      return {
        name: 'checkbarname,checkclassname,insertBarmilkUpload',
        importParams: '栏舍名称,牲畜类别,牛头数,环境温度（℃）,平均月龄,体重（kg）,日增重（kg）,怀孕天数,胎次,平均泌乳天数,产奶量（kg/头）,乳脂率（%）,乳蛋白率（%）,乳糖率（%）,记录人,生效日期',
        sheetname: 'Sheet1',
        // 登录牧场
        pastureid: Cookies.get('pastureid'),
        // 日期参数
        dateParams: '生效日期',
        // 必填参数
        requiredParams: '栏舍名称',
        // 为数值的参数
        numParams: '牛头数,环境温度（℃）,平均月龄,体重（kg）,日增重（kg）,怀孕天数,胎次,平均泌乳天数,产奶量（kg/头）,乳脂率（%）,乳蛋白率（%）,乳糖率（%）'
      }
    },
    // 设置上传地址
    uploadExcelUrl() {
      return process.env.VUE_APP_BASE_API + 'authdata/ImportExcel'
    }
  },
  created() {
    this.getList()
    this.getDownList()
     this.getDownList2()
    this.getButtons()
  },
  methods: {
    getButtons() {
      const Edit = 'Performance'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    getDownList() {
      GetDataByNames(this.requestParams).then(response => {
        this.houseNameList = response.data.getBarListEnable.list
        this.livestockList = response.data.getCowclassListEnable.list
      })
    },
    getDownList2() {
      GetDataByNames([{ name: 'getDictByName', offset: 0, pagecount: 0, params: ['牲畜父类'] }]).then(response => {
        this.parentList = response.data.getDictByName.list
      })
    },
    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    getList() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    form_search() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.getList()
    },
    handleRefresh() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.barid = ''
      this.table.getdataListParm.parammaps.cowclass = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.offset = 1
      this.getList()
    },

    // 新增
    resetTemp() {
      this.create.temp = { pastureid: Cookies.get('pastureid'), productdate: parseTime(new Date(), '{y}-{m}-{d}'), emp: Cookies.get('employename'), barid: '', barname: '', cowclassid: '', cowclass: '', bigcowclass: '', cowsum: '', tem: '', avgmonthage: '', bw: '', dayw: '', dayspre: '', fetal: '', avgdim: '', product: '', fat: '', pro: '', lactose: '' }
    },
    blurEmp(item) {
      this.create.temp.emp = item.target.value
    },
    // 栏舍名称
    changeBar(item) {
      this.create.temp.barname = this.houseNameList.find(obj => obj.id === item).bname
    },
    // 牲畜类别
    changeCowclass(item) {
      this.create.temp.cowclass = this.livestockList.find(obj => obj.id === item).classname
      this.create.temp.bigcowclass = this.livestockList.find(obj => obj.id === item).parentname
    },


    changeParent(val) {
      console.log('点击了牲畜类别父类', val)


      this.create.temp.cowclass = this.parentList.find(obj => obj.id === item).label
      this.create.temp.bigcowclass = this.parentList.find(obj => obj.id === item).label
    },

    getNoteTakerList() {
      GetDataByName(this.create.getdataListParm).then(response => {
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            response.data.list[i].myId = i
          }
          this.create.noteTakerList = response.data.list
          console.log('记录人数据', response.data.list)
          console.log(this.create.noteTakerList)
        } else {
          this.create.noteTakerList = []
        }
      })
    },
    handleCreate() {
      console.log('点击了新增')
      this.dialogFull = false
      this.resetTemp()
      this.getNoteTakerList()
      this.create.dialogStatus = 'create'
      this.create.dialogFormVisible = true
    },
    createData() {
      console.log('点击了新增保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const positiveInteger = /^[1-9]\d*$/
          // 牛头数
          if (this.create.temp.cowsum !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.cowsum))) {
              this.$message({ type: 'error', message: '牛头数请输入正整数', duration: 2000 })
              return false
            }
          }
          const twoDecimalPlaces = /^\d+(\.\d{1,2})?$/
          // 温度环境
          if (this.create.temp.tem !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.tem))) {
              this.$message({ type: 'error', message: '温度环境请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 平均月龄
          if (this.create.temp.avgmonthage !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.avgmonthage))) {
              this.$message({ type: 'error', message: '平均月龄请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 体重
          if (this.create.temp.bw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.bw))) {
              this.$message({ type: 'error', message: '体重请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 日增重
          if (this.create.temp.dayw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.dayw))) {
              this.$message({ type: 'error', message: '日增重请保留两位小数', duration: 2000 })
              return false
            }
          }
          const dayspre = /^(([1-9]|([1-9]\d)|(1\d\d)|(2([0-7]\d|7[0-9]))))$/
          // 怀孕天数
          if (this.create.temp.dayspre !== '') {
            if (!dayspre.test(parseFloat(this.create.temp.dayspre))) {
              this.$message({ type: 'error', message: '怀孕天数请输入大于0小于280整数', duration: 2000 })
              return false
            }
          }
          const fetal = /^(?:[1-9]|1[0-9])$/
          // 胎次
          if (this.create.temp.fetal !== '') {
            if (!fetal.test(parseFloat(this.create.temp.fetal))) {
              this.$message({ type: 'error', message: '胎次请输入大于0小于20整数', duration: 2000 })
              return false
            }
          }
          // 平均泌乳
          if (this.create.temp.avgdim !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.avgdim))) {
              this.$message({ type: 'error', message: '平均泌乳天数请输入正整数', duration: 2000 })
              return false
            }
          }
          // 产奶量
          if (this.create.temp.product !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.product))) {
              this.$message({ type: 'error', message: '产奶量请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳脂率
          if (this.create.temp.fat !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.fat))) {
              this.$message({ type: 'error', message: '乳脂率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳蛋白率
          if (this.create.temp.pro !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.pro))) {
              this.$message({ type: 'error', message: '乳蛋白率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳糖率
          if (this.create.temp.lactose !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.lactose))) {
              this.$message({ type: 'error', message: '乳糖率请保留两位小数', duration: 2000 })
              return false
            }
          }

          this.requestParam.name = 'insertBarmilk'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.cowsum == '') { this.create.temp.cowsum = '0' }
          if (this.create.temp.tem == '') { this.create.temp.tem = '0' }
          if (this.create.temp.avgmonthage == '') { this.create.temp.avgmonthage = '0' }
          if (this.create.temp.bw == '') { this.create.temp.bw = '0' }
          if (this.create.temp.dayw == '') { this.create.temp.dayw = '0' }
          if (this.create.temp.dayspre == '') { this.create.temp.dayspre = '0' }
          if (this.create.temp.fetal == '') { this.create.temp.fetal = '0' }
          if (this.create.temp.avgdim == '') { this.create.temp.avgdim = '0' }
          if (this.create.temp.product == '') { this.create.temp.product = '0' }
          if (this.create.temp.fat == '') { this.create.temp.fat = '0' }
          if (this.create.temp.pro == '') { this.create.temp.pro = '0' }
          if (this.create.temp.lactose == '') { this.create.temp.lactose = '0' }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
              this.create.dialogFormVisible = false
              this.getList()
            } else {
              const barid = new RegExp("key 'barid'")
              if (barid.test(response.data)) {
                this.$message({ type: 'error', message: '该栏舍今日生产性能已存在，不可重复生成', duration: 2000 })
              } else {
                this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
              }
              if (this.create.temp.cowsum == '0') { this.create.temp.cowsum = '' }
              if (this.create.temp.tem == '0') { this.create.temp.tem = '' }
              if (this.create.temp.avgmonthage == '0') { this.create.temp.avgmonthage = '' }
              if (this.create.temp.bw == '0') { this.create.temp.bw = '' }
              if (this.create.temp.dayw == '0') { this.create.temp.dayw = '' }
              if (this.create.temp.dayspre == '0') { this.create.temp.dayspre = '' }
              if (this.create.temp.fetal == '0') { this.create.temp.fetal = '' }
              if (this.create.temp.avgdim == '0') { this.create.temp.avgdim = '' }
              if (this.create.temp.product == '0') { this.create.temp.product = '' }
              if (this.create.temp.fat == '0') { this.create.temp.fat = '' }
              if (this.create.temp.pro == '0') { this.create.temp.pro = '' }
              if (this.create.temp.lactose == '0') { this.create.temp.lactose = '' }
            }
          })
        }
      })
    },
    createDataAgain() {
      console.log('点击了新增保存')
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const positiveInteger = /^[1-9]\d*$/
          // 牛头数
          if (this.create.temp.cowsum !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.cowsum))) {
              this.$message({ type: 'error', message: '牛头数请输入正整数', duration: 2000 })
              return false
            }
          }
          const twoDecimalPlaces = /^\d+(\.\d{1,2})?$/
          // 温度环境
          if (this.create.temp.tem !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.tem))) {
              this.$message({ type: 'error', message: '温度环境请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 平均月龄
          if (this.create.temp.avgmonthage !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.avgmonthage))) {
              this.$message({ type: 'error', message: '平均月龄请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 体重
          if (this.create.temp.bw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.bw))) {
              this.$message({ type: 'error', message: '体重请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 日增重
          if (this.create.temp.dayw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.dayw))) {
              this.$message({ type: 'error', message: '日增重请保留两位小数', duration: 2000 })
              return false
            }
          }
          const dayspre = /^(([1-9]|([1-9]\d)|(1\d\d)|(2([0-7]\d|7[0-9]))))$/
          // 怀孕天数
          if (this.create.temp.dayspre !== '') {
            if (!dayspre.test(parseFloat(this.create.temp.dayspre))) {
              this.$message({ type: 'error', message: '怀孕天数请输入大于0小于280整数', duration: 2000 })
              return false
            }
          }
          const fetal = /^(?:[1-9]|1[0-9])$/
          // 胎次
          if (this.create.temp.fetal !== '') {
            if (!fetal.test(parseFloat(this.create.temp.fetal))) {
              this.$message({ type: 'error', message: '胎次请输入大于0小于20整数', duration: 2000 })
              return false
            }
          }
          // 平均泌乳
          if (this.create.temp.avgdim !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.avgdim))) {
              this.$message({ type: 'error', message: '平均泌乳天数请输入正整数', duration: 2000 })
              return false
            }
          }
          // 产奶量
          if (this.create.temp.product !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.product))) {
              this.$message({ type: 'error', message: '产奶量请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳脂率
          if (this.create.temp.fat !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.fat))) {
              this.$message({ type: 'error', message: '乳脂率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳蛋白率
          if (this.create.temp.pro !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.pro))) {
              this.$message({ type: 'error', message: '乳蛋白率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳糖率
          if (this.create.temp.lactose !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.lactose))) {
              this.$message({ type: 'error', message: '乳糖率请保留两位小数', duration: 2000 })
              return false
            }
          }

          this.requestParam.name = 'insertBarmilk'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.cowsum == '') { this.create.temp.cowsum = '0' }
          if (this.create.temp.tem == '') { this.create.temp.tem = '0' }
          if (this.create.temp.avgmonthage == '') { this.create.temp.avgmonthage = '0' }
          if (this.create.temp.bw == '') { this.create.temp.bw = '0' }
          if (this.create.temp.dayw == '') { this.create.temp.dayw = '0' }
          if (this.create.temp.dayspre == '') { this.create.temp.dayspre = '0' }
          if (this.create.temp.fetal == '') { this.create.temp.fetal = '0' }
          if (this.create.temp.avgdim == '') { this.create.temp.avgdim = '0' }
          if (this.create.temp.product == '') { this.create.temp.product = '0' }
          if (this.create.temp.fat == '') { this.create.temp.fat = '0' }
          if (this.create.temp.pro == '') { this.create.temp.pro = '0' }
          if (this.create.temp.lactose == '') { this.create.temp.lactose = '0' }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
              this.resetTemp()
              this.create.noteTakerList = []
              this.getNoteTakerList()
            } else {
              const barid = new RegExp("key 'barid'")
              if (barid.test(response.data)) {
                this.$message({ type: 'error', message: '该栏舍今日生产性能已存在，不可重复生成', duration: 2000 })
              } else {
                this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
              }
              if (this.create.temp.cowsum == '0') { this.create.temp.cowsum = '' }
              if (this.create.temp.tem == '0') { this.create.temp.tem = '' }
              if (this.create.temp.avgmonthage == '0') { this.create.temp.avgmonthage = '' }
              if (this.create.temp.bw == '0') { this.create.temp.bw = '' }
              if (this.create.temp.dayw == '0') { this.create.temp.dayw = '' }
              if (this.create.temp.dayspre == '0') { this.create.temp.dayspre = '' }
              if (this.create.temp.fetal == '0') { this.create.temp.fetal = '' }
              if (this.create.temp.avgdim == '0') { this.create.temp.avgdim = '' }
              if (this.create.temp.product == '0') { this.create.temp.product = '' }
              if (this.create.temp.fat == '0') { this.create.temp.fat = '' }
              if (this.create.temp.pro == '0') { this.create.temp.pro = '' }
              if (this.create.temp.lactose == '0') { this.create.temp.lactose = '' }
            }
          })
        }
      })
    },

    // 编辑
    handleUpdate(row) {
      this.dialogFull = false
      console.log('点击了编辑', row)
      row.barid = String(row.barid)
      // row.cowclassid = String(row.cowclassid)
      this.create.temp = Object.assign({}, row)
      this.create.temp.id = row.id
      if (this.create.temp.cowsum == '0') { this.create.temp.cowsum = '' }
      if (this.create.temp.avgdim == '0') { this.create.temp.avgdim = '' }
      if (this.create.temp.dayspre == '0') { this.create.temp.dayspre = '' }
      if (this.create.temp.fetal == '0') { this.create.temp.fetal = '' }
      this.getNoteTakerList()
      this.create.dialogStatus = 'update'
      this.create.dialogFormVisible = true
    },
    updateData() {
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          const positiveInteger = /^[1-9]\d*$/
          // 牛头数
          if (this.create.temp.cowsum !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.cowsum))) {
              this.$message({ type: 'error', message: '牛头数请输入正整数', duration: 2000 })
              return false
            }
          }
          const twoDecimalPlaces = /^\d+(\.\d{1,2})?$/
          // 温度环境
          if (this.create.temp.tem !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.tem))) {
              this.$message({ type: 'error', message: '温度环境请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 平均月龄
          if (this.create.temp.avgmonthage !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.avgmonthage))) {
              this.$message({ type: 'error', message: '平均月龄请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 体重
          if (this.create.temp.bw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.bw))) {
              this.$message({ type: 'error', message: '体重请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 日增重
          if (this.create.temp.dayw !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.dayw))) {
              this.$message({ type: 'error', message: '日增重请保留两位小数', duration: 2000 })
              return false
            }
          }
          const dayspre = /^(([1-9]|([1-9]\d)|(1\d\d)|(2([0-7]\d|7[0-9]))))$/
          // 怀孕天数
          if (this.create.temp.dayspre !== '') {
            if (!dayspre.test(parseFloat(this.create.temp.dayspre))) {
              this.$message({ type: 'error', message: '怀孕天数请输入大于0小于280整数', duration: 2000 })
              return false
            }
          }
          const fetal = /^(?:[1-9]|1[0-9])$/
          // 胎次
          if (this.create.temp.fetal !== '') {
            if (!fetal.test(parseFloat(this.create.temp.fetal))) {
              this.$message({ type: 'error', message: '胎次请输入大于0小于20整数', duration: 2000 })
              return false
            }
          }
          // 平均泌乳
          if (this.create.temp.avgdim !== '') {
            if (!positiveInteger.test(parseFloat(this.create.temp.avgdim))) {
              this.$message({ type: 'error', message: '平均泌乳天数请输入正整数', duration: 2000 })
              return false
            }
          }
          // 产奶量
          if (this.create.temp.product !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.product))) {
              this.$message({ type: 'error', message: '产奶量请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳脂率
          if (this.create.temp.fat !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.fat))) {
              this.$message({ type: 'error', message: '乳脂率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳蛋白率
          if (this.create.temp.pro !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.pro))) {
              this.$message({ type: 'error', message: '乳蛋白率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // 乳糖率
          if (this.create.temp.lactose !== '') {
            if (!twoDecimalPlaces.test(parseFloat(this.create.temp.lactose))) {
              this.$message({ type: 'error', message: '乳糖率请保留两位小数', duration: 2000 })
              return false
            }
          }
          // cowclass
          this.requestParam.name = 'updateBarmilk'
          this.requestParam.parammaps = this.create.temp
          if (this.create.temp.cowsum == '') { this.create.temp.cowsum = '0' }
          if (this.create.temp.tem == '') { this.create.temp.tem = '0' }
          if (this.create.temp.avgmonthage == '') { this.create.temp.avgmonthage = '0' }
          if (this.create.temp.bw == '') { this.create.temp.bw = '0' }
          if (this.create.temp.dayw == '') { this.create.temp.dayw = '0' }
          if (this.create.temp.dayspre == '') { this.create.temp.dayspre = '0' }
          if (this.create.temp.fetal == '') { this.create.temp.fetal = '0' }
          if (this.create.temp.avgdim == '') { this.create.temp.avgdim = '0' }
          if (this.create.temp.product == '') { this.create.temp.product = '0' }
          if (this.create.temp.fat == '') { this.create.temp.fat = '0' }
          if (this.create.temp.pro == '') { this.create.temp.pro = '0' }
          if (this.create.temp.lactose == '') { this.create.temp.lactose = '0' }
          PostDataByName(this.requestParam).then(response => {
            console.log('新增保存发送参数', this.requestParam)
            if (response.msg !== 'fail') {
              this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
              this.create.dialogFormVisible = false
              this.getList()
            } else {
              this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
              if (this.create.temp.dayspre == '0') { this.create.temp.dayspre = '' }
              if (this.create.temp.fetal == '0') { this.create.temp.fetal = '' }
              if (this.create.temp.cowsum == '0') { this.create.temp.cowsum = '' }
              if (this.create.temp.avgdim == '0') { this.create.temp.avgdim = '' }
            }
          })
        }
      })
    },

    // 删除
    handleRowDelete(row) {
      console.log('点击了行内删除')
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.selectList = []
        this.requestParam.name = 'deleteBarmilk'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = row.pastureid
        this.requestParam.parammaps.id = row.id
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
            this.getList()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    handleSelectionChange(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    form_delete() {
      console.log('点击了删除')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择栏舍', duration: 2000 })
      } else {
        MessageBox.confirm('当前选中' + this.selectList.length + '条信息，是否删除?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList }}
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = { 'name': 'deleteBarmilk', 'type': 'e', 'parammaps': {
            id: '@insertSpotList.id',
            pastureid: '@insertSpotList.pastureid'
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        })
      }
    },
    // 复制
    handleCopy() {
      console.log('点击了复制')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择栏舍', duration: 2000 })
      } else if (this.selectList.length == 1) {
        MessageBox.confirm('是否确认复制此信息?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          this.requestParam.name = 'copybarmilk'
          this.requestParam.parammaps = {}
          this.requestParam.parammaps.pastureid = this.selectList[0].pastureid
          this.requestParam.parammaps.id = this.selectList[0].id
          PostDataByName(this.requestParam).then(response => {
            if (response.msg === 'fail') {
              const barid = new RegExp("key 'barid'")
              if (barid.test(response.data)) {
                this.$notify({ type: 'warning', message: '该栏舍今日生产性能已存在，不可重复生成', duration: 2000 })
                return
              }
              this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        }).catch(() => {
          this.$message({ type: 'info', message: '已取消复制' })
        })
      } else {
        this.$message({ type: 'error', message: '请选择一条栏舍生产性能', duration: 2000 })
      }
    },
    // 导出
    handleExport(item) {
      if (item == 1) {
        console.log('点击了导出模板')
        // https://kptyun.cn:8081/file/导入导出模板/栏舍生产/栏舍生产性能导入模板.xlsx
        const requestParam = this.requestParam
        const url = process.env.VUE_APP_BASE_API + 'file/导入导出模板/栏舍生产/栏舍生产性能导入模板.xlsx' // 请求下载文件的地址
        console.log(url)
        axios({
          method: 'GET',
          url: url,
          data: requestParam,
          headers: { token: getToken(), optname: 'insertcustomdoc' },
          responseType: 'blob'
        }).then(res => {
          if (!res) return
          this.percentage = 99
          setTimeout(() => {
            this.isPercentage = false
          }, 2000)
          const blob = new Blob([res.data], {
            type: 'application/octet-stream;charset=utf-8'
          })
          const url = window.URL.createObjectURL(blob)
          const aLink = document.createElement('a')
          aLink.style.display = 'none'
          aLink.href = url
          const docname = '栏舍生产性能导入模板.xlsx'
          aLink.setAttribute('download', docname) // 下载的文件
          document.body.appendChild(aLink)
          aLink.click()
          document.body.removeChild(aLink)
          window.URL.revokeObjectURL(url)
        })
      } else {
        console.log('点击了导出数据')
        this.download.getdataListParm.parammaps = this.table.getdataListParm.parammaps
        if (this.download.getdataListParm.parammaps.inputDatetime !== '' && this.download.getdataListParm.parammaps.inputDatetime !== null) {
          this.download.getdataListParm.parammaps.startTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
          this.download.getdataListParm.parammaps.stopTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
        } else {
          this.download.getdataListParm.parammaps.inputDatetime = ''
          this.download.getdataListParm.parammaps.startTime = ''
          this.download.getdataListParm.parammaps.stopTime = ''
        }
        GetDataByName(this.download.getdataListParm).then(response => {
          if (response.data.list !== null) {
            this.download.list = response.data.list
          } else {
            this.download.list = []
          }
          var excelDatas = [
            {
              tHeader: ['栏舍名称', '牲畜类别', '牛头数', '环境温度（℃）', '平均月龄', '体重（kg）', '日增重（kg）', '怀孕天数', '胎次', '平均泌乳天数', '产奶量（kg/头）', '乳脂率（%）', '乳蛋白率（%）', '乳糖率（%）', '记录人', '生效日期'],
              filterVal: ['barname', 'cowclass', 'cowsum', 'tem', 'avgmonthage', 'bw', 'dayw', 'dayspre', 'fetal', 'avgdim', 'product', 'fat', 'pro', 'lactose', 'emp', 'productdate'],
              tableDatas: this.download.list,
              sheetName: 'Sheet1'
            }
          ]
          json2excel(excelDatas, '栏舍生产性能', true, 'xlsx')
        })
      }
    },
    beforeImport(file) {
      const isLt2M = file.size / 1024 / 1024 < 2
      if (!isLt2M) {
        this.$message.error('上传文件大小不能超过 2MB!')
      }
      return isLt2M
    },
    handleImportSuccess(res, file) {
      this.getList()
      if (res.msg === 'ok') {
        this.$message({ title: '成功', message: '导入成功:' + res.data.success + '条!', type: 'success', duration: 2000 })
        if (res.data.err_count > 0) {
          this.$notify({ title: '失败', message: '导入失败:' + res.data.err_count + '条!', type: 'danger', duration: 2000 })
           import('@/vendor/Export2Excel').then(excel => {
             const list1 = res.data.result
             const tHeader = [
               '栏舍名称', '牲畜类别', '牛头数', '环境温度（℃）', '平均月龄', '体重（kg）', '日增重（kg）', '怀孕天数', '胎次', '平均泌乳天数', '产奶量（kg/头）', '乳脂率（%）', '乳蛋白率（%）', '乳糖率（%）', '记录人', '生效日期', '错误信息'
             ]
             const filterVal = [
               '栏舍名称', '牲畜类别', '牛头数', '环境温度（℃）', '平均月龄', '体重（kg）', '日增重（kg）', '怀孕天数', '胎次', '平均泌乳天数', '产奶量（kg/头）', '乳脂率（%）', '乳蛋白率（%）', '乳糖率（%）', '记录人', '生效日期', 'error_msg'
             ]
             const data1 = this.formatJson(filterVal, list1)
             excel.export_json_to_excel({ header: tHeader, data: data1, filename: '栏舍生产性能导入报错信息', autoWidth: true, bookType: 'xlsx' })
           })
        }
      } else {
        this.$notify({ title: '失败', message: '上传失败', type: 'danger', duration: 2000 })
      }
    },
    formatJson(filterVal, jsonData) {
      return jsonData.map(v =>
        filterVal.map(j => {
          if (j === 'timestamp') {
            return parseTime(v[j])
          } else {
            return v[j]
          }
        })
      )
    }
  }
}

</script>
